module GuidGen(genGuid) where

import Time
import System.CPUTime
import System.Info
import SHA1
import Random
import GenUtil
import Monad



genGuid :: Bool -> IO String
genGuid verb = do
    r <- fmap show (randomIO :: IO Integer)
    t <- fmap show getClockTime
    rb <- fmap (take 100) $ catch  (readFile "/dev/urandom")(\_ -> return [])
    let gs = (r ++ t ++ os ++ arch ++ rb) 
    when verb $ putErrLn $ "Generating hash from " ++ show gs
    return $ sha1ShowHash $ sha1 gs
